import { useForm, Controller } from 'react-hook-form'
import { Box, Input } from '@chakra-ui/react'
import React, { useEffect, useRef } from 'react'

type Inputs = {
  name: string
  age: string
}

export const FormTest = () => {
  const {
    register,
    control,
    handleSubmit,
    watch,
    reset,
    setValue,
    formState: { errors },
  } = useForm<Inputs>()

  const [name, setName] = React.useState('')
  const [age, setAge] = React.useState('12')
  const ageRef = useRef(null)

  useEffect(() => {
    ageRef.current.focus()
  }, [])

  const onSibmit = ({ name, age }) => {
    // console.log(1111111, name, age)
  }

  return (
    <Box
      as="form"
      flexDirection="column"
      display="flex"
      onSubmit={handleSubmit(onSibmit)}
    >
      <label>
        Name:
        <Controller
          control={control}
          name="name"
          rules={{
            required: 'required 4 now',
            minLength: { value: 4, message: 'min 4 now' },
          }}
          render={({ field, fieldState, formState }) => <Input {...field} />}
        />
      </label>

      <label>
        Age:
        <input type="number" ref={ageRef} defaultValue={age} />
      </label>
      <button type="submit">Submit</button>
    </Box>
  )
}
