import { HStack, Icon } from '@chakra-ui/react'
import { FaRegStar, FaStar } from 'react-icons/fa6'
import React, { useMemo, useState } from 'react'
import { stars } from '../__data__/context'
import { useUsers } from '../hooks'

const useStars = (currentRated, starsCount) => {
  const [rated, setRated] = useState(currentRated)
  const stars = useMemo(
    () =>
      Array.from({ length: starsCount }).map((_, index) => index + 1 > rated),
    [starsCount, rated],
  )

  return {
    setRated,
    stars,
  }
}

export const Stars = ({
  count,
  // rated,
  // setRated,
  userId,
}: {
  count: number
  userId: 'some-user-id' | '2'
  // rated: number
  // setRated: (rate: number) => void
}) => {
  // const {
  //   stars,
  //   setRated: starsSetRated
  // } = useStars(rated, count)
  const { rate, setUserRate } = useUsers(state => state[userId].rated)

  return (
    <HStack>
      {Array.from({ length: count }).map((_, index) =>
        index + 1 > rate ? (
          <Icon
            key={index}
            color="orange.400"
            cursor="pointer"
            onClick={() => setUserRate(userId, index + 1)}
          >
            <FaRegStar />
          </Icon>
        ) : (
          <Icon
            key={index}
            color="orange.400"
            cursor="pointer"
            onClick={() => setUserRate(userId, index + 1)}
          >
            <FaStar />
          </Icon>
        ),
      )}
    </HStack>
  )
}
