import { useEffect, useState, useSyncExternalStore } from 'react'

import { usersStore } from './__data__/users'

export const useUsers = <StatePart>(selector: (state: ReturnType<typeof usersStore.getState>) => StatePart) => {
  // const [rate, setRate] = useState(selector(usersStore.getState()))

  // useEffect(() => {
  //   const unsubscribe = usersStore.subscribe(() => {
  //     setRate(selector(usersStore.getState()))
  //   })

  //   return unsubscribe
  // }, [])

  const rate = useSyncExternalStore(usersStore.subscribe, () =>
    selector(usersStore.getState()),
  )

  return {
    rate,
    setUserRate: (userId: string, rate: number) =>
      usersStore.setState({
        ...usersStore.getState(),
        [userId]: {
          ...usersStore.getState()[userId],
          rated: rate,
        },
      }),
  }
}
